void disass(int *pc, char *st){
	int A,b,d,r,k,q,opc;
	opc=flash[*pc].opcode;
	(*pc)++;

	if (opc==0x0000){ /* nop */
		sprintf(st,"nop");
		return;
	}

	if (opc==0x9598){ /* break */
		sprintf(st,"break");
		return;
	}

	if (opc==0x9488){ /* clc */
		sprintf(st,"clc");
		return;
	}

	if (opc==0x94D8){ /* clh */
		sprintf(st,"clh");
		return;
	}

	if (opc==0x94F8){ /* cli */
		sprintf(st,"cli");
		return;
	}

	if (opc==0x94A8){ /* cln */
		sprintf(st,"cln");
		return;
	}

	if (opc==0x94C8){ /* cls */
		sprintf(st,"cls");
		return;
	}

	if (opc==0x94E8){ /* clt */
		sprintf(st,"clt");
		return;
	}

	if (opc==0x94B8){ /* clv */
		sprintf(st,"clv");
		return;
	}

	if (opc==0x9498){ /* clz */
		sprintf(st,"clz");
		return;
	}

	if (opc==0x9519){ /* eicall */
		sprintf(st,"eicall");
		return;
	}

	if (opc==0x9419){ /* eijmp */
		sprintf(st,"eijmp");
		return;
	}

	if (opc==0x9509){ /* icall */
		sprintf(st,"icall");
		return;
	}

	if (opc==0x9409){ /* ijmp */
		sprintf(st,"ijmp");
		return;
	}

	if (opc==0x9508){ /* ret */
		sprintf(st,"ret");
		return;
	}

	if (opc==0x9518){ /* reti */
		sprintf(st,"reti");
		return;
	}

	if (opc==0x9408){ /* sec */
		sprintf(st,"sec");
		return;
	}

	if (opc==0x9458){ /* seh */
		sprintf(st,"seh");
		return;
	}

	if (opc==0x9478){ /* sei */
		sprintf(st,"sei");
		return;
	}

	if (opc==0x9428){ /* sen */
		sprintf(st,"sen");
		return;
	}

	if (opc==0x9448){ /* ses */
		sprintf(st,"ses");
		return;
	}

	if (opc==0x9468){ /* set */
		sprintf(st,"set");
		return;
	}

	if (opc==0x9438){ /* sev */
		sprintf(st,"sev");
		return;
	}

	if (opc==0x9418){ /* sez */
		sprintf(st,"sez");
		return;
	}

	if (opc==0x9588){ /* sleep */
		sprintf(st,"sleep");
		return;
	}

	if (opc==0x95E8){ /* spm */
		sprintf(st,"spm");
		return;
	}

	if (opc==0x95A8){ /* wdr */
		sprintf(st,"wdr");
		return;
	}

	if ((opc&0xFF0F)==0xEF0F){ /* ser */
		d=(opc>>4)&0x0f;
		sprintf(st,"ser r%d",d+16);
		return;
	}

	if ((opc&0xFE0F)==0x9405){ /* asr */
		d=(opc>>4)&0x1f;
		sprintf(st,"asr r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9400){ /* com */
		d=(opc>>4)&0x1f;
		sprintf(st,"com r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x940A){ /* dec */
		d=(opc>>4)&0x1f;
		sprintf(st,"dec r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9403){ /* inc */
		d=(opc>>4)&0x1f;
		sprintf(st,"inc r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9000){ /* lds */
		d=(opc>>4)&0x1f;
		k=flash[*pc].opcode;
		(*pc)++;
		sprintf(st,"lds r%d,0x%x",d,k);
		return;
	}

	if ((opc&0xFE0F)==0x9200){ /* sts */
		d=(opc>>4)&0x1f;
		k=flash[*pc].opcode;
		(*pc)++;
		sprintf(st,"sts r%d,0x%x",d,k);
		return;
	}

	if ((opc&0xFE0F)==0x9406){ /* lsr */
		d=(opc>>4)&0x1f;
		sprintf(st,"lsr r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9401){ /* neg */
		d=(opc>>4)&0x1f;
		sprintf(st,"neg r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x900F){ /* pop */
		d=(opc>>4)&0x1f;
		sprintf(st,"pop r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x920F){ /* push */
		d=(opc>>4)&0x1f;
		sprintf(st,"push r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9407){ /* ror */
		d=(opc>>4)&0x1f;
		sprintf(st,"ror r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9402){ /* swap */
		d=(opc>>4)&0x1f;
		sprintf(st,"swap r%d",d);
		return;
	}

	if ((opc&0xFE0E)==0x940E){ /* call */
		k=((opc>>3)&0x3e)+(opc&1);
		k<<=16;
		k+=flash[*pc].opcode;
		(*pc)++;
		sprintf(st,"call 0x%x",k);
		return;
	}

	if ((opc&0xFF88)==0x0308){ /* fmul */
		d=(opc>>4)&0x7;
		r=opc&7;
		sprintf(st,"fmul r%d,r%d",d+16,r+16);
		return;
	}

	if ((opc&0xFF88)==0x0380){ /* fmuls */
		d=(opc>>4)&0x7;
		r=opc&7;
		sprintf(st,"fmuls r%d,r%d",d+16,r+16);
		return;
	}

	if ((opc&0xFF88)==0x0388){ /* fmulsu */
		d=(opc>>4)&0x7;
		r=opc&7;
		sprintf(st,"fmulsu r%d,r%d",d+16,r+16);
		return;
	}

	if ((opc&0xFE0E)==0x940C){ /* jmp */
		k=((opc>>3)&0x3e)+(opc&1);
		k<<=16;
		k+=flash[*pc].opcode;
		(*pc)++;
		sprintf(st,"jmp 0x%x",k);
		return;
	}

	if ((opc&0xFF88)==0x0300){ /* mulsu */
		d=(opc>>4)&0x7;
		r=opc&7;
		sprintf(st,"mulsu r%d,r%d",d+16,r+16);
		return;
	}

	if ((opc&0xFC07)==0xF400){ /* brcc */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brcc 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF000){ /* brcs */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brcs 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF001){ /* breq */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"breq 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF404){ /* brge */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brge 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF405){ /* brhc */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brhc 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF005){ /* brhs */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brhs 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF407){ /* brid */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brid 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF007){ /* brie */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brie 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF004){ /* brlt */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brlt 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF002){ /* brmi */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brmi 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF401){ /* brne */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brne 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF402){ /* brpl */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brpl 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF406){ /* brtc */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brtc 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF006){ /* brts */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brts 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF403){ /* brvc */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brvc 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFC07)==0xF003){ /* brvs */
		k=(opc>>3)&0x7f;
		if(k>63) k-=128;
		sprintf(st,"brvs 0x%04x",*pc+k);
		return;
	}

	if ((opc&0xFF00)==0x9700){ /* sbiw */
		k=((opc>>2)&0x30)+(opc&0x0f);
		d=(opc>>4)&3;
		sprintf(st,"sbiw r%d,%d",d*2+24,k);
		return;
	}

	if ((opc&0xFF00)==0x9600){ /* adiw */
		k=((opc>>2)&0x30)+(opc&0x0f);
		d=(opc>>4)&3;
		sprintf(st,"adiw r%d,%d",d*2+24,k);
		return;
	}

	if ((opc&0xFE08)==0xF800){ /* bld */
		d=(opc>>4)&0x1f;
		b=opc&7;
		sprintf(st,"bld r%d,%d",d,b);
		return;
	}

	if ((opc&0xFE08)==0xFA00){ /* bst */
		d=(opc>>4)&0x1f;
		b=opc&7;
		sprintf(st,"bst r%d,%d",d,b);
		return;
	}

	if ((opc&0xFF00)==0x9A00){ /* sbi */
		A=(opc>>3)&0x1f;
		b=opc&7;
		sprintf(st,"sbi %s,%d",io_names[A+32],b);
		return;
	}

	if ((opc&0xFF00)==0x9800){ /* cbi */
		A=(opc>>3)&0x1f;
		b=opc&7;
		sprintf(st,"cbi %s,%d",io_names[A+32],b);
		return;
	}

	if ((opc&0xFF00)==0x0100){ /* movw */
		d=(opc>>4)&0x0f;
		r=opc&0x0f;
		sprintf(st,"movw r%d,r%d",d<<1,r<<1);
		return;
	}

	if ((opc&0xFF00)==0x0200){ /* muls */
		d=(opc>>4)&0x0f;
		r=opc&0x0f;
		sprintf(st,"muls r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFF00)==0x9900){ /* sbic */
		A=(opc>>3)&0x1f;
		b=opc&7;
		sprintf(st,"sbic %d,%d",A,b);
		return;
	}

	if ((opc&0xFF00)==0x9B00){ /* sbis */
		A=(opc>>3)&0x1f;
		b=opc&7;
		sprintf(st,"sbis %d,%d",A,b);
		return;
	}

	if ((opc&0xFE08)==0xFC00){ /* sbrc */
		r=(opc>>4)&0x1f;
		b=opc&7;
		sprintf(st,"sbrc r%d,%d",r,b);
		return;
	}

	if ((opc&0xFE08)==0xFE00){ /* sbrs */
		r=(opc>>4)&0x1f;
		b=opc&7;
		sprintf(st,"sbrs r%d,%d",r,b);
		return;
	}

	if (opc==0x95c8)		{ /* lpm1 */
		sprintf(st,"lpm r0,z");
		return;
	}

	if ((opc&0xFE0F)==0x9004){ /* lpm2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"lpm r%d,z",d);
		return;
	}

	if ((opc&0xFE0F)==0x9005){ /* lpm3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"lpm r%d,z+",d);
		return;
	}

	if ((opc&0xFC00)==0x1C00){ /* adc */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		if(r==d) sprintf(st,"rol r%d",r);
		else sprintf(st,"adc r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x0C00){ /* add */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		if(r==d) sprintf(st,"lsl r%d",r);
		else sprintf(st,"add r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x2000){ /* and */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		if(r==d) sprintf(st,"tst r%d",d);
		else sprintf(st,"and r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x0400){ /* cpc */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"cpc r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x1400){ /* cp */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"cp r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x1000){ /* cpse */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"cpse r%d,r%d",d,r);
		return;
	}

	if (opc==0x95d8){ /* elpm1 */
		d=(opc>>4)&0x1f;
		sprintf(st,"elpm r0,z");
		return;
	}

	if ((opc&0xFE0F)==0x9006){ /* elpm2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"elpm r%d,z",d);
		return;
	}

	if ((opc&0xFE0F)==0x9007){ /* elpm3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"elpm r%d,z+",d);
		return;
	}

	if ((opc&0xFC00)==0x2400){ /* eor */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		if(r==d) sprintf(st,"clr r%d",d);
		else sprintf(st,"eor r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFE0F)==0x900C){ /* ld x1 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,x",d);
		return;
	}

	if ((opc&0xFE0F)==0x900D){ /* ld x2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,x+",d);
		return;
	}

	if ((opc&0xFE0F)==0x900E){ /* ld x3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,-x",d);
		return;
	}

	if ((opc&0xFE0F)==0x8008){ /* ld y1 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,y",d);
		return;
	}

	if ((opc&0xFE0F)==0x9009){ /* ld y2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,y+",d);
		return;
	}

	if ((opc&0xFE0F)==0x900A){ /* ld y3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,-y",d);
		return;
	}

	if ((opc&0xD208)==0x8008){ /* ldd y */
		d=(opc>>4)&0x1f;
		q=((opc>>8)&0x20)+((opc>>7)&0x18)+(opc&7);
		sprintf(st,"ldd r%d,y+%d",d,q);
		return;
	}

	if ((opc&0xFE0F)==0x8000){ /* ld z1 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,z",d);
		return;
	}

	if ((opc&0xFE0F)==0x9001){ /* ld z2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,z+",d);
		return;
	}

	if ((opc&0xFE0F)==0x9002){ /* ld z3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"ld r%d,-z",d);
		return;
	}

	if ((opc&0xD208)==0x8000){ /* ldd z */
		d=(opc>>4)&0x1f;
		q=((opc>>8)&0x20)+((opc>>7)&0x18)+(opc&7);
		sprintf(st,"ldd r%d,z+%d",d,q);
		return;
	}



	if ((opc&0xFE0F)==0x920C){ /* st x1 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st x,r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x920D){ /* st x2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st x+,r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x920E){ /* st x3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st -x,r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x8208){ /* st y1 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st y,r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9209){ /* st y2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st y+,r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x920A){ /* st y3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st -y,r%d",d);
		return;
	}

	if ((opc&0xD208)==0x8208){ /* std y */
		d=(opc>>4)&0x1f;
		q=((opc>>8)&0x20)+((opc>>7)&0x18)+(opc&7);
		sprintf(st,"std y+%d,r%d",q,d);
		return;
	}

	if ((opc&0xFE0F)==0x8200){ /* st z1 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st z,r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9201){ /* st z2 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st z+,r%d",d);
		return;
	}

	if ((opc&0xFE0F)==0x9202){ /* st z3 */
		d=(opc>>4)&0x1f;
		sprintf(st,"st -z,r%d",d);
		return;
	}

	if ((opc&0xD208)==0x8200){ /* std z */
		d=(opc>>4)&0x1f;
		q=((opc>>8)&0x20)+((opc>>7)&0x18)+(opc&7);
		sprintf(st,"std z+%d,r%d",q,d);
		return;
	}

	if ((opc&0xFC00)==0x2C00){ /* mov */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"mov r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x9C00){ /* mul */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"mul r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x2800){ /* or */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"or r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x0800){ /* sbc */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"sbc r%d,r%d",d,r);
		return;
	}

	if ((opc&0xFC00)==0x1800){ /* sub */
		r=((opc>>5)&0x10)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"sub r%d,r%d",d,r);
		return;
	}

	if ((opc&0xF800)==0xB000){ /* in */
		A=((opc>>5)&0x30)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"in r%d,%s",d,io_names[A+32]);
		return;
	}

	if ((opc&0xF800)==0xB800){ /* out */
		A=((opc>>5)&0x30)+(opc&0x0f);
		d=(opc>>4)&0x01f;
		sprintf(st,"out %s,r%d",io_names[A+32],d);
		return;
	}

	if ((opc&0xF000)==0x7000){ /* andi */
		k=((opc>>4)&0xf0)+(opc&0x0f);
		d=(opc>>4)&0x0f;
		sprintf(st,"andi r%d,0x%02x",d+16,k);
		return;
	}

	if ((opc&0xF000)==0x3000){ /* cpi */
		k=((opc>>4)&0xf0)+(opc&0x0f);
		d=(opc>>4)&0x0f;
		sprintf(st,"cpi r%d,0x%02x",d+16,k);
		return;
	}

	if ((opc&0xF000)==0xE000){ /* ldi */
		k=((opc>>4)&0xf0)+(opc&0x0f);
		d=(opc>>4)&0x0f;
		sprintf(st,"ldi r%d,0x%02x",d+16,k);
		return;
	}

	if ((opc&0xF000)==0x6000){ /* ori */
		k=((opc>>4)&0xf0)+(opc&0x0f);
		d=(opc>>4)&0x0f;
		sprintf(st,"ori r%d,0x%02x",d+16,k);
		return;
	}

	if ((opc&0xF000)==0xD000){ /* rcall */
		k=opc&0xfff;
		if(k>2047) k-=4096;
		sprintf(st,"rcall %04X",*pc+k);
		return;
	}

	if ((opc&0xF000)==0xC000){ /* rjmp */
		k=opc&0xfff;
		if(k>2047) k-=4096;
		sprintf(st,"rjmp %04X",*pc+k);
		return;
	}

	if ((opc&0xF000)==0x4000){ /* sbci */
		k=((opc>>4)&0xf0)+(opc&0x0f);
		d=(opc>>4)&0x0f;
		sprintf(st,"sbci r%d,0x%02x",d+16,k);
		return;
	}

	if ((opc&0xF000)==0x5000){ /* subi */
		k=((opc>>4)&0xf0)+(opc&0x0f);
		d=(opc>>4)&0x0f;
		sprintf(st,"subi r%d,0x%02x",d+16,k);
		return;
	}


		sprintf(st,"ill opc 0x%04X",opc);
		return;
}
